<?php

if (!defined('FORUM') ) die();
if (!defined('FORUM_ROOT'))
	define('FORUM_ROOT', '../../');

if ($forum_config['o_similar_topics_enable'] == '1' && FORUM_PAGE == 'viewtopic') 
{
    if (!isset($lang_similar_topics)) {
	    if (file_exists($ext_info['path'].'/lang/'.$forum_user['language'].'/'.$ext_info['id'].'.php'))
	        require $ext_info['path'].'/lang/'.$forum_user['language'].'/'.$ext_info['id'].'.php';
        else
	        require $ext_info['path'].'/lang/English/'.$ext_info['id'].'.php';
    }

    if (!isset($lang_forum))
	    require FORUM_ROOT.'lang/'.$forum_user['language'].'/forum.php';

    ob_start();

    $query = array(
	    'SELECT'	=> 't.id, t.subject',
	    'FROM'		=> 'topics AS t',
    );

    if ($forum_config['o_similar_topics_source'] == '1')
	    $query['WHERE'] = 't.forum_id='.$cur_topic['forum_id'];

    $result = $forum_db->query_build($query) or error(__FILE__, __LINE__);

    $num_sim_topics = $forum_config['o_similar_topics_count'];
    $uniqueness = $forum_config['o_similar_topics_uniqueness'];
    $sim_count = 0;
    $topics_id = $topics = array();
    while ($row = $forum_db->fetch_assoc($result)) 
	{
	    similar_text(utf8_strtolower($row['subject']), utf8_strtolower($cur_topic['subject']), $part);
        $similarity_part = floor($part);

        if ($similarity_part > $uniqueness) {
            if ($id != $row['id'] && $sim_count < $num_sim_topics) {
                $topics_id[] = $row['id'];
                $sim_count++;
            }
        }
    }

    if (!empty($topics_id))
    {
	    $query = array(
		    'SELECT'	=> 't.id, t.poster, t.subject, t.posted, t.first_post_id, t.last_post, t.last_post_id, t.last_poster, t.num_views, t.num_replies, t.closed, t.sticky, t.moved_to',
		    'FROM'		=> 'topics AS t',
		    'WHERE'		=> 't.id IN ('.implode(',', $topics_id).')',
            'ORDER BY'	=> 't.posted DESC',
	    );

	    if (!$forum_user['is_guest'] && $forum_config['o_show_dot'] == '1')
	    {
		    $query['SELECT'] .= ', p.poster_id AS has_posted';
		    $query['JOINS'][]	= array(
			    'LEFT JOIN'		=> 'posts AS p',
			    'ON'			=> '(p.poster_id='.$forum_user['id'].' AND p.topic_id=t.id)'
		    );

		    $query['GROUP BY'] = 't.id, t.poster, t.subject, t.posted, t.first_post_id, t.last_post, t.last_post_id, t.last_poster, t.num_views, t.num_replies, t.closed, t.sticky, t.moved_to, p.poster_id';
	    }
		
		if (function_exists('get_avatar')) 
        {		
			$query['SELECT'] .= ', u.id AS poster_id, u.avatar, u.avatar_width, u.avatar_height, t.last_post_id';
            $query['JOINS'][] = array(
                'LEFT JOIN' => 'posts AS p',
                'ON'            => '(p.id = t.last_post_id)'
            );

            $query['JOINS'][] = array(
                'LEFT JOIN' => 'users AS u',
                'ON'            => '(u.id = p.poster_id)'
            );
		}
		
	    $result = $forum_db->query_build($query) or error(__FILE__, __LINE__);

	    while ($c_topic = $forum_db->fetch_assoc($result))
	    {
		    $topics[] = $c_topic;
	    }

        $forum_page['item_header'] = array();
        $forum_page['item_header']['subject']['title'] = '<strong class="subject-title">'.$lang_forum['Topics'].'</strong>';
        $forum_page['item_header']['info']['replies'] = '<strong class="info-replies">'.$lang_forum['replies'].'</strong>';

        if ($forum_config['o_topic_views'] == '1')
	        $forum_page['item_header']['info']['views'] = '<strong class="info-views">'.$lang_forum['views'].'</strong>';

        $forum_page['item_header']['info']['lastpost'] = '<strong class="info-lastpost">'.$lang_forum['last post'].'</strong>';
?>
	    <div class="main-head">
		    <h2 class="hn"><span><?php echo $lang_similar_topics['Similar topics'] ?></span></h2>
	    </div>
	    <div class="main-subhead">
		    <p class="item-summary<?php echo ($forum_config['o_topic_views'] == '1') ? ' forum-views' : ' forum-noview' ?>"><span><?php printf($lang_forum['Forum subtitle'], implode(' ', $forum_page['item_header']['subject']), implode(', ', $forum_page['item_header']['info'])) ?></span></p>
	    </div>
	    <div id="forum<?php echo $c_topic['forum_id'] ?>" class="main-content main-forum<?php echo ($forum_config['o_topic_views'] == '1') ? ' forum-views' : ' forum-noview' ?>">
<?php

	    $forum_page['item_count'] = 0;

	    foreach ($topics as $c_topic)
	    {
		    ++$forum_page['item_count'];

		    $forum_page['item_subject'] = $forum_page['item_body'] = $forum_page['item_status'] = $forum_page['item_nav'] = $forum_page['item_title'] = $forum_page['item_title_status'] = array();

		    if ($forum_config['o_censoring'] == '1')
			    $c_topic['subject'] = censor_words($c_topic['subject']);

		    $forum_page['item_subject']['starter'] = '<span class="item-starter">'.sprintf($lang_forum['Topic starter'], forum_htmlencode($c_topic['poster'])).'</span>';

		    if ($c_topic['moved_to'] != null)
		    {
			    $forum_page['item_status']['moved'] = 'moved';
			    $forum_page['item_title']['link'] = '<span class="item-status"><em class="moved">'.sprintf($lang_forum['Item status'], $lang_forum['Moved']).'</em></span> <a href="'.forum_link($forum_url['topic'], array($c_topic['moved_to'], sef_friendly($c_topic['subject']))).'">'.forum_htmlencode($c_topic['subject']).'</a>';

			    $forum_page['item_body']['subject']['title'] = '<h3 class="hn"><span class="item-num">'.forum_number_format($forum_page['start_from'] + $forum_page['item_count']).'</span>'.$forum_page['item_title']['link'].'</h3>';
			    
				($hook = get_hook('similar_topic_loop_moved_topic_pre_item_subject_merge')) ? eval($hook) : null;
				
				$forum_page['item_body']['info']['replies'] = '<li class="info-replies"><span class="label">'.$lang_forum['No replies info'].'</span></li>';

			    if ($forum_config['o_topic_views'] == '1')
				    $forum_page['item_body']['info']['views'] = '<li class="info-views"><span class="label">'.$lang_forum['No views info'].'</span></li>';

			    $forum_page['item_body']['info']['lastpost'] = '<li class="info-lastpost"><span class="label">'.$lang_forum['No lastpost info'].'</span></li>';
		    }
		    else
		    {
			    if (!$forum_user['is_guest'] && $forum_config['o_show_dot'] == '1' && $c_topic['has_posted'] == $forum_user['id'])
			    {
				    $forum_page['item_title']['posted'] = '<span class="posted-mark">'.$lang_forum['You posted indicator'].'</span>';
				    $forum_page['item_status']['posted'] = 'posted';
			    }

			    if ($c_topic['sticky'] == '1')
			    {
				    $forum_page['item_title_status']['sticky'] = '<em class="sticky">'.$lang_forum['Sticky'].'</em>';
				    $forum_page['item_status']['sticky'] = 'sticky';
			    }

			    if ($c_topic['closed'] == '1')
			    {
				    $forum_page['item_title_status']['closed'] = '<em class="closed">'.$lang_forum['Closed'].'</em>';
				    $forum_page['item_status']['closed'] = 'closed';
			    }

			    if (!empty($forum_page['item_title_status']))
				    $forum_page['item_title']['status'] = '<span class="item-status">'.sprintf($lang_forum['Item status'], implode(', ', $forum_page['item_title_status'])).'</span>';

			    $forum_page['item_title']['link'] = '<a href="'.forum_link($forum_url['topic'], array($c_topic['id'], sef_friendly($c_topic['subject']))).'">'.forum_htmlencode($c_topic['subject']).'</a>';
			    
				($hook = get_hook('similar_topic_loop_normal_topic_pre_item_title_merge')) ? eval($hook) : null;
				
				$forum_page['item_body']['subject']['title'] = '<h3 class="hn"><span class="item-num">'.forum_number_format($forum_page['start_from'] + $forum_page['item_count']).'</span> '.implode(' ', $forum_page['item_title']).'</h3>';

			    if (empty($forum_page['item_status']))
				    $forum_page['item_status']['normal'] = 'normal';

			    $forum_page['item_pages'] = ceil(($c_topic['num_replies'] + 1) / $forum_user['disp_posts']);

			    if ($forum_page['item_pages'] > 1)
				    $forum_page['item_nav']['pages'] = '<span>'.$lang_forum['Pages'].'&#160;</span>'.paginate($forum_page['item_pages'], -1, $forum_url['topic'], $lang_common['Page separator'], array($c_topic['id'], sef_friendly($c_topic['subject'])));

			    if (!$forum_user['is_guest'] && $c_topic['last_post'] > $forum_user['last_visit'] && (!isset($tracked_topics['topics'][$c_topic['id']]) || $tracked_topics['topics'][$c_topic['id']] < $c_topic['last_post']) && (!isset($tracked_topics['forums'][$id]) || $tracked_topics['forums'][$id] < $c_topic['last_post']))
			    {
				    $forum_page['item_nav']['new'] = '<em class="item-newposts"><a href="'.forum_link($forum_url['topic_new_posts'], array($c_topic['id'], sef_friendly($c_topic['subject']))).'">'.$lang_forum['New posts'].'</a></em>';
				    $forum_page['item_status']['new'] = 'new';
			    }

			    if (!empty($forum_page['item_nav']))
				    $forum_page['item_subject']['nav'] = '<span class="item-nav">'.sprintf($lang_forum['Topic navigation'], implode('&#160;&#160;', $forum_page['item_nav'])).'</span>';

			    $forum_page['item_body']['info']['replies'] = '<li class="info-replies"><strong>'.forum_number_format($c_topic['num_replies']).'</strong> <span class="label">'.(($c_topic['num_replies'] == 1) ? $lang_forum['reply'] : $lang_forum['replies']).'</span></li>';

			    if ($forum_config['o_topic_views'] == '1')
				    $forum_page['item_body']['info']['views'] = '<li class="info-views"><strong>'.forum_number_format($c_topic['num_views']).'</strong> <span class="label">'.(($c_topic['num_views'] == 1) ? $lang_forum['view'] : $lang_forum['views']).'</span></li>';

			    $forum_page['item_body']['info']['lastpost'] = '<li class="info-lastpost"><span class="label">'.$lang_forum['Last post'].'</span> <strong><a href="'.forum_link($forum_url['post'], $c_topic['last_post_id']).'">'.format_time($c_topic['last_post']).'</a></strong> <cite>'.sprintf($lang_forum['by poster'], forum_htmlencode($c_topic['last_poster'])).'</cite></li>';
		    }
			
			if (function_exists('get_avatar')) 
            {  
   			    if ($c_topic['moved_to'] == null) {
                    $avatar = '<img src="'. get_avatar(array('id' => $c_topic['poster_id'], 'avatar' => $c_topic['avatar'] )) .'" width="40px" class="list-avatar" />';

					if (isset($forum_config['o_mini_user_profile_version']) && $forum_config['o_mini_user_profile_version'] >= '0.5' && $forum_user['mini_user_profile_enable'] == '1')
					    $forum_page['item_body']['info']['lastpost'] =  str_replace('<span class="label">'.$lang_forum['Last post'].'</span>', '<div class="ul-lastpost"><span class="ulabel mp_link" poster_id="'.$c_topic['poster_id'].'" onclick="window.location.href = \''.forum_link($forum_url['user'], $c_topic['poster_id']).'\';">'.$avatar.'</span></div>', $forum_page['item_body']['info']['lastpost']);
					else
						$forum_page['item_body']['info']['lastpost'] =  str_replace('<span class="label">'.$lang_forum['Last post'].'</span>', '<div class="ul-lastpost"><span class="ulabel" poster_id="'.$c_topic['poster_id'].'">'.$avatar.'</span></div>', $forum_page['item_body']['info']['lastpost']);
                }
			}

		    $forum_page['item_body']['subject']['desc'] = '<p>'.implode(' ', $forum_page['item_subject']).'</p>';
		    $forum_page['item_style'] = (($forum_page['item_count'] % 2 != 0) ? ' odd' : ' even').(($forum_page['item_count'] == 1) ? ' main-first-item' : '').((!empty($forum_page['item_status'])) ? ' '.implode(' ', $forum_page['item_status']) : '');
?>
		    <div id="topic<?php echo $c_topic['id'] ?>" class="main-item<?php echo $forum_page['item_style'] ?>" style="padding-left:0;">
			    <div class="item-subject">
				    <?php echo implode("\n\t\t\t\t", $forum_page['item_body']['subject'])."\n" ?>
			    </div>
			    <ul class="item-info">
				    <?php echo implode("\n\t\t\t\t", $forum_page['item_body']['info'])."\n" ?>
			    </ul>
		    </div>
<?php
	    }
?>
	    </div>
<?php
    }

    $similar_topics = forum_trim(ob_get_contents());
    $main_elements['<!-- forum_crumbs_end -->'] .= $similar_topics;
    ob_end_clean();
}

